%define name    mongodb
%define version 2.0.3
%define subrel	1
%define release %mkrel 4

Name:    %{name}
Version: %{version}
Release: %{release}
Summary: MongoDB client shell and tools
License: AGPL 3.0
URL: http://www.mongodb.org
Group: Databases
Source0: http://downloads.mongodb.org/src/%{name}-src-r%{version}.tar.gz
Source1: mongod.service
Patch0: mongodb-2.0.3-CVE-2013-1892-1.patch
Patch1: mongodb-2.0.3-CVE-2013-1892-2.patch
BuildRequires: js-devel
BuildRequires: readline-devel
BuildRequires: boost-devel
BuildRequires: pcre-devel
BuildRequires: pcap-devel
BuildRequires: scons

%description
Mongo (from "huMONGOus") is a schema-free document-oriented database.
It features dynamic profileable queries, full indexing, replication
and fail-over support, efficient storage of large binary data objects,
and auto-sharding.

This package provides the mongo shell, import/export tools, and other
client utilities.

%package server
Summary: MongoDB server, sharding server, and support scripts
Group: Databases
Requires: mongodb
Requires(post):  rpm-helper >= 0.24.8-1
Requires(preun): rpm-helper >= 0.24.8-1


%description server
Mongo (from "huMONGOus") is a schema-free document-oriented database.

This package provides the mongo server software, mongo sharding server
softwware, default configuration files, and init.d scripts.

%prep
%setup -qn %{name}-src-r%{version}
%patch0 -p1
%patch1 -p1

%build
%serverbuild
export CXXFLAGS="%optflags -DBOOST_FILESYSTEM_VERSION=2"
export LINKFLAGS='%ldflags'
%scons --prefix=%{_prefix}

%install
rm -rf %{buildroot}
%serverbuild
export CXXFLAGS="%optflags -DBOOST_FILESYSTEM_VERSION=2"
export LINKFLAGS='%ldflags'

%scons --prefix=%{buildroot}%{_usr} install
mkdir -p %{buildroot}%{_mandir}/man1
cp debian/*.1 %{buildroot}%{_mandir}/man1/
mkdir -p %{buildroot}%{_unitdir}
cp %{SOURCE1} %{buildroot}%{_unitdir}/mongod.service
mkdir -p %{buildroot}%{_sysconfdir}/rc.d/init.d
cp rpm/init.d-mongod %{buildroot}%{_sysconfdir}/rc.d/init.d/mongod
chmod a+x %{buildroot}%{_sysconfdir}/rc.d/init.d/mongod
mkdir -p %{buildroot}%{_sysconfdir}
cp rpm/mongod.conf %{buildroot}%{_sysconfdir}/mongod.conf
mkdir -p %{buildroot}%{_sysconfdir}/sysconfig
cp rpm/mongod.sysconfig %{buildroot}%{_sysconfdir}/sysconfig/mongod
mkdir -p %{buildroot}%{_var}/lib/mongo
mkdir -p %{buildroot}%{_var}/log/mongo
touch %{buildroot}%{_var}/log/mongo/mongod.log

cat >> %{buildroot}%{_sysconfdir}/sysconfig/mongod << EOF
OPTIONS="-f /etc/mongod.conf"
EOF

# (cg) Ensure the pid file folder exists (this is more important under mga3
# when /var/run will be on tmpfs)
mkdir -p %{buildroot}%{_prefix}/lib/tmpfiles.d
cat > %{buildroot}%{_prefix}/lib/tmpfiles.d/%{name}-server.conf << EOF
d %{_var}/run/mongo 0755 mongod mongod -
EOF

%clean
rm -rf %{buildroot}

%pre server
%_pre_useradd mongod /var/lib/mongo /bin/false

%post server
# (cg) Make sure the pid folder exists on install
mkdir -p %{_var}/run/mongo
chown mongod.mongod %{_var}/run/mongo
%_post_service mongod

%preun server
%_preun_service mongod

%postun server
%_postun_userdel mongod

%files
%doc README GNU-AGPL-3.0.txt
%{_bindir}/mongo
%{_bindir}/mongodump
%{_bindir}/mongoexport
%{_bindir}/mongofiles
%{_bindir}/mongoimport
%{_bindir}/mongorestore
%{_bindir}/mongostat
%{_bindir}/mongosniff
%{_bindir}/mongotop
%{_bindir}/bsondump
%{_mandir}/man1/mongo.1*
%{_mandir}/man1/mongodump.1*
%{_mandir}/man1/mongoexport.1*
%{_mandir}/man1/mongofiles.1*
%{_mandir}/man1/mongoimport.1*
%{_mandir}/man1/mongosniff.1*
%{_mandir}/man1/mongostat.1*
%{_mandir}/man1/mongorestore.1*
%{_mandir}/man1/bsondump.1*

%files server
%config(noreplace) %{_sysconfdir}/mongod.conf
%{_bindir}/mongod
%{_bindir}/mongos
%{_mandir}/man1/mongod.1*
%{_mandir}/man1/mongos.1*
%{_prefix}/lib/tmpfiles.d/%{name}-server.conf
%{_unitdir}/mongod.service
%{_sysconfdir}/rc.d/init.d/mongod
%{_sysconfdir}/sysconfig/mongod
%attr(0755,mongod,mongod) %dir %{_var}/lib/mongo
%attr(0755,mongod,mongod) %dir %{_var}/log/mongo
%attr(0640,mongod,mongod) %config(noreplace) %verify(not md5 size mtime) %{_var}/log/mongo/mongod.log


%changelog

* Tue Apr 09 2013 luigiwalser <luigiwalser> 2.0.3-4.1.mga2
+ Revision: 409192
- add patches from upstream to fix CVE-2013-1892 (upstream SERVER-9124)

  + tmb <tmb>
    - Require rpm-helper >= 0.24.8-1 for systemd support

* Sun Apr 22 2012 colin <colin> 2.0.3-3.mga2
+ Revision: 232648
- Future proof creation of pid folder via tmpfiles.d

* Sun Apr 22 2012 colin <colin> 2.0.3-2.mga2
+ Revision: 232641
- Add systemd support

* Fri Mar 02 2012 fwang <fwang> 2.0.3-1.mga2
+ Revision: 216624
- new version 2.0.3

* Fri Dec 16 2011 fwang <fwang> 2.0.2-1.mga2
+ Revision: 182401
- new version 2.0.2

* Mon Nov 28 2011 fwang <fwang> 2.0.1-2.mga2
+ Revision: 173614
- rebuild for new boost

* Wed Nov 02 2011 fwang <fwang> 2.0.1-1.mga2
+ Revision: 161545
- new version 2.0.1

* Sat Sep 17 2011 fwang <fwang> 2.0.0-1.mga2
+ Revision: 144569
- update file list
- new version 2.0.0

* Sat Sep 03 2011 fwang <fwang> 1.8.3-1.mga2
+ Revision: 138125
- new version 1.9.3
- rebuild for new boost

* Wed Jun 22 2011 fwang <fwang> 1.8.2-1.mga2
+ Revision: 111869
- new version 1.8.2

* Sat Mar 26 2011 dmorgan <dmorgan> 1.6.5-2.mga1
+ Revision: 77586
- imported package mongodb

